
/*       |                 |
         |<- clientino.c ->|
         |                 |
       
        By ..::SNHYPER::..
        snhyper@hotmail.com
    
    [[ Program under GNU General Public License ]]

    To  compile   => gcc -c clientino.c -o clientino
*/



#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* Numero di porta sulla quale il client richiede la connessione */

#define PORT 4000

/* inizializzo indirizzi */

void addr_initialize(struct sockaddr_in *indirizzo, int port, long IPaddr)
{
   indirizzo->sin_family = AF_INET;

  /* htons: host to network conversion, short */

   indirizzo->sin_port = htons((u_short) port);
   indirizzo->sin_addr.s_addr = IPaddr;
}

/* principale */

void main(int argc, char* argv[])
{
   /* Descrittore del socket */

   int sd;

   /* Indirizzo server */

   struct sockaddr_in server_addr;

   /* Indirizzo client */

   struct sockaddr_in mio_addr;

   /* Dimensione indirizzo client */

   int mio_addr_len=sizeof(mio_addr);

   /* Controllo connect() */

   int error;

    /*  Inizializza lindirizzo del server, alla funzione viene passato un puntatore alla struttura che
        identifica il server addres nella quale mette il numero di porta passato come secondo parametro
        lindirizzo IP inserito da riga di comando (argv[1]) e convertito nel formato di rete con la
        inet_addr() */

   addr_initialize(&server_addr, PORT, inet_addr(argv[1]));

   /* Crea identificatore socket */

   sd=socket(AF_INET,SOCK_STREAM,0);

   /* crea connessione sul socket appena creato */

   error=connect(sd,(struct sockaddr*) &server_addr, sizeof(server_addr));

   /* Controllo la connect() */

   if (error==0)
      {

      /* Se ha avuto effetto positivo stampo: Connessione effettuata */

      printf("Connessione effettuata\n");

      /* Scrive nell'indirizzo in mio_addr l'indirizzo del client tramite la getsockname() */

      getsockname(sd, &mio_addr, &mio_addr_len);

      /* Stampa in STDOUT la porta del client dopo avero convertito dal formato di rete al formato
         dell host tramite la ntohs() */

      printf("La mia porta e': %d\n\n",ntohs(mio_addr.sin_port));

      /* chiudo socket */

      close(sd);
      }

   else printf("%s","\nErrore connessione\n\n");

   /* Se non  andata a buon fine chiudo socket */

   close(sd);
}

