
/*       |                 |
         |<- serverino.c ->|
         |                 |
       
        By ..::SNHYPER::..
        snhyper@hotmail.com
 
    [[ Program under GNU General Public License ]]
   
    To  compile   => gcc -c serverino.c -o serverino
*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* Definisco numero di porta  */

#define PORT 4000 

/* Definisco numero massimo connessioni da lasciare in coda */

#define MAXCONN 5

/* inizializzo indirizzi */

void addr_initialize(struct sockaddr_in *indirizzo, int port, long IPaddr)
{
   indirizzo->sin_family = AF_INET;
   indirizzo->sin_port = htons((u_short) port);

            /* htons: host to network conversion, short */

   indirizzo->sin_addr.s_addr = IPaddr;
}

/* principale */

void main(int argc, char * argv[])
{

   /* Identificatori canale pubblico e canale privato */

   int sd,new_sd;

   /* Indirizzo Server */

   struct sockaddr_in server_addr;

   /* Indirizzo client */

   struct sockaddr_in client_addr;

   /* Dimensione indirizzo client */

   int client_len=sizeof(client_addr);

   /* Inizializzo indirizzo server per accettare connessione sulla 4000 e da qualunque indirizzo IP (INADDR_ANY) */

   addr_initialize(&server_addr, PORT, INADDR_ANY);

   /* Creo canale pubblico */

   sd=socket(AF_INET,SOCK_STREAM,0);

   /* Lego al socket indirizzo server */

   bind(sd,(struct sockaddr*) &server_addr,sizeof(server_addr));

   /* Imposto numero massimo di connessioni in coda */

   listen(sd,MAXCONN);
   printf("Entro in attesa di connessioni\n");

   /* Preleva il proprio port dalla struttura che identifica lindirizzo del server, lo converte da
       formato di rete a formato dell host e lo stampa STDOUT */

   printf("Ho sulla mia porta: %d\n", ntohs(server_addr.sin_port));

   /* Creo canale privato per connessione con un client */

   new_sd=accept(sd,(struct sockaddr*) &client_addr, &client_len);

   /* Se la accept()  sbloccata significa che si  connesso un client */

   printf("\n\nAccettata connessione\n");

   /* Preleva il port del client, dopo averlo trasformato da formato di rete a formato host lo stampa a video */

   printf("Dal client con porta: %d\n\n", ntohs(client_addr.sin_port));

   /* Chiudo canale privato */

   close(new_sd);

   /* Chiudo canale pubblico */

   close(sd);
}

